/*
 I.T.T. Cerulli Giulianova
 Dip: Elettronica - Elettrotecnica
 Lab: T.D.P. / T.P.S.
 Esempio controllo temperatura di un caseificio
 LCD usato 20 X 4 Marca: CTC modello: CMC420N01
 
 The circuit:
 * LCD RS pin to digital pin 9
 * LCD Enable pin to digital pin 8
 * LCD D4 pin to digital pin 7
 * LCD D5 pin to digital pin 6
 * LCD D6 pin to digital pin 5
 * LCD D7 pin to digital pin 4
 * LCD R/W pin to ground GND
 * 10K resistor:
   * ends to +5V (VDD pin 2 LCD) and ground (VSS pin 1 LCD)
   * wiper to LCD VO pin (pin 3)
   * pin 13 arduino relè (dispositivo reffreddante)
   * pin 12 arduino allarme sonoro (buzzer)
   * pin A0 ingresso sensore LM 35
 
 realizzato dal prof. Benignetti e dagli studenti 
 Pawel Kowalewski e Edoardo Di Fabio 
 latest modified: 25 Feb 2015
 
 This example and code is in the public domain.
 http://www.francescobenignetti.it/robotica/arduino/

 */

// include the library code:
#include <LiquidCrystal.h>
float tempLM35;
// initialize the library with the numbers of the interface pins
LiquidCrystal lcd (9, 8, 7, 6, 5, 4);

void setup() 
{
  analogRead (A0); 
  pinMode (12,OUTPUT);
  pinMode (13,OUTPUT);
  // set up the LCD's number of columns and rows: 
  lcd.begin (20, 4);  
}
void loop()
{  start:
  lcd.setCursor (0,0);
  lcd.print ("TEMPERATURA di:  ");
  tempLM35 = (5.0 * analogRead (A0) * 100) / 1023;
  lcd.setCursor (0,1);
  lcd.print (tempLM35);
  
  lcd.print  ( (char) 223);
  lcd.print (  'C'   );
  if (tempLM35>=22.50) // ciclo di controllo ridondante della temperatura di intervento elettroventola
{digitalWrite (13,HIGH);}
  else if (tempLM35<22.50)
  
{delay (250); digitalWrite (13,LOW);} // ciclo di controllo ridondante della temperatura di intervento elettroventola

if (tempLM35>=25)  // ciclo di controllo della temperatura di allarme con intervento del cicalino

{
 tone (12, 2000, 1000); // generatore tono di allarme
 delay (1000);
 tone (12, 440, 2000);
 delay(2000);
 noTone(12);

 lcd.clear();
 lcd.setCursor (0,4);
 lcd.print ("Verificare guasto");
}
else 
{ 
 lcd.setCursor (0,4);
 lcd.print ("                        ");
  goto start;
}
delay (250);
}


